"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("./decorators/config");
__export(require("./decorators"));
function addServices(parentExports, services) {
    console.log(module.parent && module.parent.exports === parentExports);
    if (module.parent && module.parent.exports && Object.keys(module.parent.exports).length) {
        Object.assign(parentExports, module.parent.exports, { default: null });
        return;
    }
    return services.reduce((config, Service, i) => (Object.assign({}, config, getServiceConfig(parentExports, Service, i))), {});
}
exports.addServices = addServices;
function getServiceConfig(parentExports, Service, i) {
    const serviceFunctions = Service[config_1.FUNCTIONS_METADATA];
    return Object.keys(serviceFunctions).reduce((serviceConfig, functionName) => {
        const localName = `service${i}_${functionName}`;
        parentExports[localName] = (...args) => {
            const service = new Service();
            return service[`__invoke_${functionName}`](...args);
        };
        return Object.assign({}, serviceConfig, { [functionName]: Object.assign({}, serviceFunctions[functionName], { handler: `functions.${localName}` }) });
    }, {});
}
